﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;

namespace TreasureRaiders
{
    class ThrowInput
    {
        private float deadZoneSize = 0.1f;
        public static int ACTION_DISGUISE_1 = 0;
        public static int ACTION_DISGUISE_2 = 1;
        public static int ACTION_DISGUISE_3 = 2;
        public static int ACTION_REALITY_1 = 3;
        public static int ACTION_REALITY_2 = 4;
        public static int ACTION_REALITY_3 = 5;

        //Checks if the victory screen should be closed
        //Pass in true if player 1 won, only the player that won can close the victory screen         
        public bool shouldCloseVictoryScreen(Player player)
        {
            //check several buttons to see if we close the victory screen
            return GamePad.GetState((PlayerIndex)player.Controller).Buttons.A == ButtonState.Pressed ||
                GamePad.GetState((PlayerIndex)player.Controller).Buttons.B == ButtonState.Pressed ||
                GamePad.GetState((PlayerIndex)player.Controller).Buttons.X == ButtonState.Pressed;
        }

        //Returns 1 if the player wants to rematch, -1 if the user wants to quit, and 0 if the user selects nothing        
        public int rematch(Player player)
        {
            if (GamePad.GetState((PlayerIndex)player.Controller).Buttons.X == ButtonState.Pressed)
            {
                return 1;
            }
            else if (GamePad.GetState((PlayerIndex)player.Controller).Buttons.B == ButtonState.Pressed)
            {
                return -1;
            }
            return 0;
        }

        //Controls for Disguise (Thumbstick), and Reality (Buttons)
        public void checkPlayerThrowControls(Player player)
        {
            int xStick = 0;
            if (Math.Abs(GamePad.GetState((PlayerIndex)player.Controller).ThumbSticks.Left.X) > deadZoneSize)
                xStick = GamePad.GetState((PlayerIndex)player.Controller).ThumbSticks.Left.X < 0 ? -1 : 1;
            int yStick = 0;
            if (Math.Abs(GamePad.GetState((PlayerIndex)player.Controller).ThumbSticks.Left.Y) > deadZoneSize)
                yStick = GamePad.GetState((PlayerIndex)player.Controller).ThumbSticks.Left.Y < 0 ? -1 : 1;

            if (GamePad.GetState((PlayerIndex)player.Controller).Buttons.X == ButtonState.Pressed)
            {
                player.setCurrentThrowReality(Throw.MAGE);
            }

            if (GamePad.GetState((PlayerIndex)player.Controller).Buttons.A == ButtonState.Pressed)
            {
                player.setCurrentThrowReality(Throw.ARCHER);
            }

            if (GamePad.GetState((PlayerIndex)player.Controller).Buttons.B == ButtonState.Pressed)
            {
                player.setCurrentThrowReality(Throw.KNIGHT);
            }

            if (xStick == -1 && yStick == 0)
            {
                player.setCurrentThrowDisguise(Throw.MAGE);
            }

            if (xStick == 0 && yStick == -1)
            {
                player.setCurrentThrowDisguise(Throw.ARCHER);
            }

            if (xStick == 1 && yStick == 0)
            {
                player.setCurrentThrowDisguise(Throw.KNIGHT);
            }
        }
    }
}
